// ImportPrimitive.cpp : implementation file
//

#include "stdafx.h"
#include "modeler.h"
#include "ImportPrimitive.h"
#include "MapGenProject.h"

#include "Include\MapGenProjectCommands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImportPrimitive dialog


CImportPrimitive::CImportPrimitive(char *pszCaption, CWnd* pParent /*=NULL*/)
	: CDialog(CImportPrimitive::IDD, pParent),
	m_pszCaption(pszCaption),
	m_pszCurrentShaderInfo(NULL),
	m_pszCurrentShaderGuid(NULL),
	m_bFatalError(FALSE)
{
	//{{AFX_DATA_INIT(CImportPrimitive)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	strcpy(m_szGuidPlusAttributes, "");

	// *** acquisisce le informazioni dal server ***

	char				szError[1024] = "";

	DWORD				dwCommand = MGPCOMM_GETCURRENTSHADERINFO;

#define			IMPORTPRIM_MGP_OUTPUT_MEM_LEN		(8*1024)

	m_pszCurrentShaderInfo = (char*)CoTaskMemAlloc(IMPORTPRIM_MGP_OUTPUT_MEM_LEN);

	if ( m_pszCurrentShaderInfo == NULL )
	{
		AfxMessageBox("Out of memory!");
		m_bFatalError = TRUE;
		return;
	}

	CMapGenProject		mgpObject(szError,
		&dwCommand, sizeof(dwCommand),
		m_pszCurrentShaderInfo, IMPORTPRIM_MGP_OUTPUT_MEM_LEN,
		theApp.m_bLocalMachine, theApp.m_szServerName);

	if ( strlen(szError) != 0 )
	{
		char		szMessage[2*1024];

		sprintf(szMessage, "Unable to establish a connection with server!\n\nClient says: <<\n%s>>", szError);

		AfxMessageBox(szMessage);
		m_bFatalError = TRUE;
		return;
	}
}

CImportPrimitive::~CImportPrimitive()
{
	if ( m_pszCurrentShaderInfo )
	{
		CoTaskMemFree(m_pszCurrentShaderInfo);
	}
}

void CImportPrimitive::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImportPrimitive)
	DDX_Control(pDX, IDC_GUID, m_wndGUID);
	DDX_Control(pDX, IDC_FORMALNAME, m_wndFormalName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImportPrimitive, CDialog)
	//{{AFX_MSG_MAP(CImportPrimitive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImportPrimitive message handlers

BOOL CImportPrimitive::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(m_pszCaption);

	// *** imposta i puntatori di m_pCheckBoxes ***

#define GETPTR(id,num) m_pCheckBoxes[id] = (CButton*)GetDlgItem(IDC_ATTRIBUTEBIT_##num);

	GETPTR(0,00)
	GETPTR(1,01)
	GETPTR(2,02)
	GETPTR(3,03)
	GETPTR(4,04)
	GETPTR(5,05)
	GETPTR(6,06)
	GETPTR(7,07)
	GETPTR(8,08)
	GETPTR(9,09)
	GETPTR(10,10)
	GETPTR(11,11)
	GETPTR(12,12)
	GETPTR(13,13)
	GETPTR(14,14)
	GETPTR(15,15)
	GETPTR(16,16)
	GETPTR(17,17)
	GETPTR(18,18)
	GETPTR(19,19)
	GETPTR(20,20)
	GETPTR(21,21)
	GETPTR(22,22)
	GETPTR(23,23)
	GETPTR(24,24)
	GETPTR(25,25)
	GETPTR(26,26)
	GETPTR(27,27)
	GETPTR(28,28)
	GETPTR(29,29)
	GETPTR(30,30)
	GETPTR(31,31)

#undef GETPTR

	// *** imposta il testo dei controlli ***

	char		*pszText = m_pszCurrentShaderInfo;

	m_wndFormalName.SetWindowText(pszText);

	pszText += strlen(pszText) + 1;

	m_wndGUID.SetWindowText( m_pszCurrentShaderGuid = pszText );

	pszText += strlen(pszText) + 1;

	for ( int i=0; i<32; i++ )
	{
		if ( strlen(pszText) )
		{
			m_pCheckBoxes[i]->SetWindowText(pszText);
		}
		pszText += strlen(pszText) + 1;
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CImportPrimitive::OnOK() 
{
	DWORD		dwAttributes = 0;

	int			index;
	DWORD		bit=1;

	for ( index=0; index<32; index++,bit<<=1 ) {

		if ( m_pCheckBoxes[index]->GetCheck() )
			dwAttributes |= bit;

	}

	sprintf(m_szGuidPlusAttributes, "(%s) %08lX", m_pszCurrentShaderGuid, dwAttributes);

	CDialog::OnOK();
}
