#ifndef __MapGenProjectCommands__H
#define __MapGenProjectCommands__H

//-------------------------------------------------------------------------------------------
#define		MGPCOMM_UNDEFINED				0x00000000

	// nessuna informazione associata

//-------------------------------------------------------------------------------------------
#define		MGPCOMM_GETSHADER				0x00000001

	// input: (36+1) caratteri del GUID

	// output:

		// E_OUTOFMEMORY:
		//		buffer passato insufficiente

		// E_FAIL:
		//		errore interno o Read senza Write

		// E_HANDLE:
		//		shader non trovato nel progetto

		// E_INVALIDARG:
		//		buffer passato con Read invalido o parametri metodo errati

		// S_OK:
		//		tex_texture_t
		//		representative texture
		//			tex_shadertex_t
		//			shader texture

//-------------------------------------------------------------------------------------------
#define		MGPCOMM_GETOBJFILESLIST			0x00000002

	// input: nessuno

	// output:

		// E_INVALIDARG:
		//		 stato passato un buffer con Read o parametri metodo errati

		// E_FAIL:
		//		errore interno o Read senza Write

		// E_OUTOFMEMORY:
		//		buffer passato insufficiente

		// S_OK:
		//		fullpath\0fullpath\0fullpath\0\0

//-------------------------------------------------------------------------------------------
#define		MGPCOMM_GETLOCALFILE			0x00000003

	// input: fullpath del file + 0

	// output:

		// E_INVALIDARG:
		//		buffer passato con Read invalido o parametri metodo errati

		// E_HANDLE:
		//		impossibile aprire il file per la lettura

		// E_OUTOFMEMORY:
		//		buffer passato insufficiente

		// E_FAIL:
		//		impossibile leggere il file o Read senza Write

		// S_OK:
		//		file contents

//-------------------------------------------------------------------------------------------
#define		MGPCOMM_GETCURRENTSHADERINFO	0x00000004

	// input: nessuno

	// output:

		// E_INVALIDARG:
		//		 stato passato un buffer con Read o parametri metodo errati

		// E_FAIL:
		//		errore interno o Read senza Write o nessuno shader selezionato

		// E_OUTOFMEMORY:
		//		buffer passato insufficiente

		// S_OK:
		//		formal name\0guid\0face attribute 0\0face attribute 1\0 ... \0face attribute 31\0\0

//-------------------------------------------------------------------------------------------

#endif