// SimplePlayer.cpp : implementation file
//

#include "stdafx.h"
#include "MODELER.h"
#include "SimplePlayer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimplePlayer

CSimplePlayer::CSimplePlayer() :
	m_bIsPlaying(FALSE),
	m_nTimerElapse(3)
{
}

CSimplePlayer::~CSimplePlayer()
{
}


BEGIN_MESSAGE_MAP(CSimplePlayer, CWnd)
	//{{AFX_MSG_MAP(CSimplePlayer)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_COMMAND(4, OnPlayPauseButton)
	ON_COMMAND(5, OnStopButton)
	ON_COMMAND(2, OnStartButton)
	ON_COMMAND(3, OnEndButton)
	ON_COMMAND(6, OnPrevButton)
	ON_COMMAND(7, OnNextButton)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSimplePlayer message handlers

int CSimplePlayer::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	// *** crea i children ***

	m_wndRenderer.m_fDiffuse[0] = 0.3f;
	m_wndRenderer.m_fDiffuse[1] = 0.9f;
	m_wndRenderer.m_fDiffuse[2] = 0.6f;
	m_wndRenderer.m_fDiffuse[3] = 1.0f;

	CRect rectDummy (0, 0, 0, 0);

	DWORD dwButtonStyle = WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | WS_DISABLED;

	if ( m_wndStart.Create("", dwButtonStyle, rectDummy, this, (UINT)2) == 0 ||
		m_wndEnd.Create("", dwButtonStyle, rectDummy, this, (UINT)3) == 0 ||
		m_wndPlayPause.Create("", dwButtonStyle, rectDummy, this, (UINT)4) == 0 ||
		m_wndStop.Create("", dwButtonStyle, rectDummy, this, (UINT)5) == 0 ||
		m_wndPrev.Create("", dwButtonStyle, rectDummy, this, (UINT)6) == 0 ||
		m_wndNext.Create("", dwButtonStyle, rectDummy, this, (UINT)7) == 0 ||
		m_wndRenderer.Create(NULL, _T(""), WS_CHILD | WS_VISIBLE, rectDummy, this, (UINT)-1) == 0 )
	{
		TRACE0("Failed to create children in CSimplePlayer::OnCreate!");
		return -1;
	}

	// *** imposta le icone ***

	m_wndStart.SetImage(theApp.LoadIcon(IDI_START));
	m_wndEnd.SetImage(theApp.LoadIcon(IDI_END));
	m_wndPlayPause.SetImage(theApp.LoadIcon(IDI_PLAY));
	m_wndStop.SetImage(theApp.LoadIcon(IDI_STOP));
	m_wndPrev.SetImage(theApp.LoadIcon(IDI_PREV));
	m_wndNext.SetImage(theApp.LoadIcon(IDI_NEXT));

	// *** imposta il testo dei tooltip ***

	m_wndStart.SetTooltip("Go to Start");
	m_wndEnd.SetTooltip("Go to End");
	m_wndPlayPause.SetTooltip("Play/Pause Animation");
	m_wndStop.SetTooltip("Stop Animation");
	m_wndPrev.SetTooltip("Previous Frame");
	m_wndNext.SetTooltip("Next Frame");

	m_wndStart.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndEnd.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndPlayPause.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndStop.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndPrev.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndNext.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);

	return 0;
}

void CSimplePlayer::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here

	// *** ricalcola il layout dei pulsanti e del renderer ***

#define BUTTONS_HEIGHT			21

	m_wndRenderer.SetWindowPos(NULL, 0, 0, cx, cy - BUTTONS_HEIGHT + 1, SWP_NOACTIVATE | SWP_NOZORDER);

	int			iButtonWidth[6], ix = 0, cx3 = (cx+1) / 3, cx3_ = (cx+1) - cx3 * 2;

	iButtonWidth[0] = cx3 / 2;
	iButtonWidth[1] = cx3 - iButtonWidth[0];
	iButtonWidth[2] = cx3 / 2;
	iButtonWidth[3] = cx3 - iButtonWidth[2];
	iButtonWidth[4] = cx3_ / 2;
	iButtonWidth[5] = cx3_ - iButtonWidth[4];

	m_wndStart		.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[0], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);
	ix += iButtonWidth[0];

	m_wndPrev		.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[1], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);
	ix += iButtonWidth[1];

	m_wndPlayPause	.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[2], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);
	ix += iButtonWidth[2];

	m_wndStop		.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[3], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);
	ix += iButtonWidth[3];

	m_wndNext		.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[4], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);
	ix += iButtonWidth[4];

	m_wndEnd		.SetWindowPos(NULL, ix, cy - BUTTONS_HEIGHT + 1, iButtonWidth[5], BUTTONS_HEIGHT, SWP_NOACTIVATE | SWP_NOZORDER);

#undef BUTTONS_HEIGHT
}

CSceneRoot *CSimplePlayer::SetSceneRoot (CSceneRoot *pSceneRoot)
{
	CSceneRoot		*pOldSceneRoot = m_wndRenderer.SetSceneRoot(pSceneRoot);

	if ( pSceneRoot != pOldSceneRoot && m_bIsPlaying )
	{
		OnPlayPauseButton();
	}

	if ( pSceneRoot == NULL )
	{
		m_wndRenderer.SetDefaultBackgroundColor();

		m_wndStart.EnableWindow(FALSE);
		m_wndEnd.EnableWindow(FALSE);
		m_wndPlayPause.EnableWindow(FALSE);
		m_wndStop.EnableWindow(FALSE);
		m_wndPrev.EnableWindow(FALSE);
		m_wndNext.EnableWindow(FALSE);

		m_wndRenderer.m_tTime = 0;
	}
	else if ( pSceneRoot != pOldSceneRoot )
	{
		m_wndRenderer.m_fBackgroundColor[0] = 175.0f/255.0f;
		m_wndRenderer.m_fBackgroundColor[1] = 175.0f/255.0f;
		m_wndRenderer.m_fBackgroundColor[2] = 175.0f/255.0f;

		BOOL		bHasTimeRange = pSceneRoot->m_pGI->first_frame == pSceneRoot->m_pGI->last_frame ? FALSE : TRUE;

		m_wndStart.EnableWindow(FALSE);
		m_wndEnd.EnableWindow(bHasTimeRange ? TRUE : FALSE);
		m_wndPlayPause.EnableWindow(bHasTimeRange ? TRUE : FALSE);
		m_wndStop.EnableWindow(FALSE);
		m_wndPrev.EnableWindow(FALSE);
		m_wndNext.EnableWindow(bHasTimeRange ? TRUE : FALSE);

		m_nTimerElapse = 1000 / pSceneRoot->m_pGI->frame_speed;

		m_nTimerElapse -= m_nTimerElapse / 3; // aumenta arbitrariamente la velocit

		if ( m_nTimerElapse == 0 )
		{
			m_nTimerElapse = 1;
		}

		m_wndRenderer.m_tTime = pSceneRoot->m_pGI->first_frame * pSceneRoot->m_pGI->ticks_per_frame;
	}

	m_wndRenderer.RedrawWindow();

	return pOldSceneRoot;
}

void CSimplePlayer::OnPlayPauseButton()
{
	if ( m_bIsPlaying == FALSE )
	{
		m_wndPlayPause.SetImage(theApp.LoadIcon(IDI_PAUSE));
		m_wndPlayPause.RedrawWindow();

		m_wndStop.EnableWindow(TRUE);

		SetTimer(69, m_nTimerElapse, NULL);

		m_bIsPlaying = TRUE;
	}
	else
	{
		m_wndPlayPause.SetImage(theApp.LoadIcon(IDI_PLAY));
		m_wndPlayPause.RedrawWindow();

		KillTimer(69);

		m_bIsPlaying = FALSE;
	}
}

void CSimplePlayer::OnTimer(UINT nIDEvent)
{
	if ( nIDEvent == 69 )
	{
		m_wndRenderer.m_tTime += m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

		if ( m_wndRenderer.m_tTime > m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
		{
			m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
		}

		m_wndRenderer.RedrawWindow();

		UpdatePlaybackButtonsState();
	}

	CWnd::OnTimer(nIDEvent);
}

void CSimplePlayer::OnStopButton()
{
	if ( m_bIsPlaying )
	{
		OnPlayPauseButton();
	}
	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();
	m_wndStop.EnableWindow(FALSE);

	UpdatePlaybackButtonsState();
}

void CSimplePlayer::OnStartButton()
{
	if ( m_bIsPlaying )
	{
		OnPlayPauseButton();
	}
	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();
	m_wndStop.EnableWindow();

	UpdatePlaybackButtonsState();
}

void CSimplePlayer::OnEndButton()
{
	if ( m_bIsPlaying )
	{
		OnPlayPauseButton();
	}
	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();
	m_wndStop.EnableWindow();

	UpdatePlaybackButtonsState();
}

void CSimplePlayer::OnPrevButton()
{
	if ( m_bIsPlaying )
	{
		OnPlayPauseButton();
	}

	m_wndRenderer.m_tTime -= m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

	if ( m_wndRenderer.m_tTime < m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
	{
		m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	}

	m_wndRenderer.RedrawWindow();
	m_wndStop.EnableWindow();

	UpdatePlaybackButtonsState();
}

void CSimplePlayer::OnNextButton()
{
	if ( m_bIsPlaying )
	{
		OnPlayPauseButton();
	}

	m_wndRenderer.m_tTime += m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

	if ( m_wndRenderer.m_tTime > m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
	{
		m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	}

	m_wndRenderer.RedrawWindow();
	m_wndStop.EnableWindow();

	UpdatePlaybackButtonsState();
}

void CSimplePlayer::UpdatePlaybackButtonsState()
{
	BOOL		bStartEnable = m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE;
	BOOL		bEndEnable = m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE;

	m_wndStart.EnableWindow(bStartEnable);
	m_wndEnd.EnableWindow(bEndEnable);
	m_wndPrev.EnableWindow(bStartEnable);
	m_wndNext.EnableWindow(bEndEnable);
}